<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!--NewPage-->
<HTML>
<HEAD>
<!-- Generated by javadoc (build 1.5.0_17) on Fri Dec 04 18:31:04 CET 2009 -->
<TITLE>
Prime
</TITLE>

<META NAME="keywords" CONTENT="ch.javasoft.math.Prime class">

<LINK REL ="stylesheet" TYPE="text/css" HREF="../../../stylesheet.css" TITLE="Style">

<SCRIPT type="text/javascript">
function windowTitle()
{
    parent.document.title="Prime";
}
</SCRIPT>
<NOSCRIPT>
</NOSCRIPT>

</HEAD>

<BODY BGCOLOR="white" onload="windowTitle();">


<!-- ========= START OF TOP NAVBAR ======= -->
<A NAME="navbar_top"><!-- --></A>
<A HREF="#skip-navbar_top" title="Skip navigation links"></A>
<TABLE BORDER="0" WIDTH="100%" CELLPADDING="1" CELLSPACING="0" SUMMARY="">
<TR>
<TD COLSPAN=2 BGCOLOR="#EEEEFF" CLASS="NavBarCell1">
<A NAME="navbar_top_firstrow"><!-- --></A>
<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="3" SUMMARY="">
  <TR ALIGN="center" VALIGN="top">
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../overview-summary.html"><FONT CLASS="NavBarFont1"><B>Overview</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="package-summary.html"><FONT CLASS="NavBarFont1"><B>Package</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#FFFFFF" CLASS="NavBarCell1Rev"> &nbsp;<FONT CLASS="NavBarFont1Rev"><B>Class</B></FONT>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="class-use/Prime.html"><FONT CLASS="NavBarFont1"><B>Use</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="package-tree.html"><FONT CLASS="NavBarFont1"><B>Tree</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../deprecated-list.html"><FONT CLASS="NavBarFont1"><B>Deprecated</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../index-files/index-1.html"><FONT CLASS="NavBarFont1"><B>Index</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../help-doc.html"><FONT CLASS="NavBarFont1"><B>Help</B></FONT></A>&nbsp;</TD>
  </TR>
</TABLE>
</TD>
<TD ALIGN="right" VALIGN="top" ROWSPAN=3><EM>
</EM>
</TD>
</TR>

<TR>
<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
&nbsp;<A HREF="../../../ch/javasoft/math/NumberOperations.html" title="interface in ch.javasoft.math"><B>PREV CLASS</B></A>&nbsp;
&nbsp;NEXT CLASS</FONT></TD>
<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
  <A HREF="../../../index.html?ch/javasoft/math/Prime.html" target="_top"><B>FRAMES</B></A>  &nbsp;
&nbsp;<A HREF="Prime.html" target="_top"><B>NO FRAMES</B></A>  &nbsp;
&nbsp;<SCRIPT type="text/javascript">
  <!--
  if(window==top) {
    document.writeln('<A HREF="../../../allclasses-noframe.html"><B>All Classes</B></A>');
  }
  //-->
</SCRIPT>
<NOSCRIPT>
  <A HREF="../../../allclasses-noframe.html"><B>All Classes</B></A>
</NOSCRIPT>


</FONT></TD>
</TR>
<TR>
<TD VALIGN="top" CLASS="NavBarCell3"><FONT SIZE="-2">
  SUMMARY:&nbsp;NESTED&nbsp;|&nbsp;FIELD&nbsp;|&nbsp;<A HREF="#constructor_summary">CONSTR</A>&nbsp;|&nbsp;<A HREF="#method_summary">METHOD</A></FONT></TD>
<TD VALIGN="top" CLASS="NavBarCell3"><FONT SIZE="-2">
DETAIL:&nbsp;FIELD&nbsp;|&nbsp;<A HREF="#constructor_detail">CONSTR</A>&nbsp;|&nbsp;<A HREF="#method_detail">METHOD</A></FONT></TD>
</TR>
</TABLE>
<A NAME="skip-navbar_top"></A>
<!-- ========= END OF TOP NAVBAR ========= -->

<HR>
<!-- ======== START OF CLASS DATA ======== -->
<H2>
<FONT SIZE="-1">
ch.javasoft.math</FONT>
<BR>
Class Prime</H2>
<PRE>
<A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Object.html" title="class or interface in java.lang">java.lang.Object</A>
  <IMG SRC="../../../resources/inherit.gif" ALT="extended by "><B>ch.javasoft.math.Prime</B>
</PRE>
<HR>
<DL>
<DT><PRE>public class <A HREF="../../../src-html/ch/javasoft/math/Prime.html#line.46"><B>Prime</B></A><DT>extends <A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Object.html" title="class or interface in java.lang">Object</A></DL>
</PRE>

<P>
The <tt>Prime</tt> contains large primes for different integer sizes, and
 functions around primes
 
 see http://primes.utm.edu/lists/2small/0bit.html
 see http://numbers.computation.free.fr/Constants/Primes/countingPrimes.html
<P>

<P>
<HR>

<P>

<!-- ======== CONSTRUCTOR SUMMARY ======== -->

<A NAME="constructor_summary"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="2"><FONT SIZE="+2">
<B>Constructor Summary</B></FONT></TH>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD><CODE><B><A HREF="../../../ch/javasoft/math/Prime.html#Prime()">Prime</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
</TABLE>
&nbsp;
<!-- ========== METHOD SUMMARY =========== -->

<A NAME="method_summary"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="2"><FONT SIZE="+2">
<B>Method Summary</B></FONT></TH>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>static&nbsp;int</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../ch/javasoft/math/Prime.html#countPrimes(int, boolean, boolean)">countPrimes</A></B>(int&nbsp;till,
                       boolean&nbsp;trace,
                       boolean&nbsp;traceAllPrimes)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Counts the primes until (inclusive) till, using default cache size,
 tracing intermediary counts if trace is true, and printing all primes
 if traceAllPrimes is true.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>static&nbsp;int</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../ch/javasoft/math/Prime.html#countPrimes(int, int, boolean, boolean)">countPrimes</A></B>(int&nbsp;till,
                       int&nbsp;cacheSize,
                       boolean&nbsp;trace,
                       boolean&nbsp;traceAllPrimes)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Counts the primes until (inclusive) till, using a cache of size cacheSize,
 tracing intermediary counts if trace is true, and printing all primes
 if traceAllPrimes is true.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>static&nbsp;int</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../ch/javasoft/math/Prime.html#getPrime(int)">getPrime</A></B>(int&nbsp;index)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Returns the <tt>index</tt><sup>th</sup> prime, for instance, 2 if index 
 is 0, 3 if index=1 and so on.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>static&nbsp;int</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../ch/javasoft/math/Prime.html#getPrime07(int)">getPrime07</A></B>(int&nbsp;index)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Ten largest  7 bit primes: (2^7 - k), k index of POW_2_TO_07_OFFSETS</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>static&nbsp;int</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../ch/javasoft/math/Prime.html#getPrime08(int)">getPrime08</A></B>(int&nbsp;index)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Ten largest  8 bit primes: (2^8 - k), k index of POW_2_TO_08_OFFSETS</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>static&nbsp;int</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../ch/javasoft/math/Prime.html#getPrime15(int)">getPrime15</A></B>(int&nbsp;index)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Ten largest  15 bit primes: (2^15 - k), k index of POW_2_TO_15_OFFSETS</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>static&nbsp;int</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../ch/javasoft/math/Prime.html#getPrime16(int)">getPrime16</A></B>(int&nbsp;index)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Ten largest  16 bit primes: (2^16 - k), k index of POW_2_TO_16_OFFSETS</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>static&nbsp;int</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../ch/javasoft/math/Prime.html#getPrime30(int)">getPrime30</A></B>(int&nbsp;index)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Ten largest  30 bit primes: (2^30 - k), k index of POW_2_TO_30_OFFSETS</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>static&nbsp;int</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../ch/javasoft/math/Prime.html#getPrime31(int)">getPrime31</A></B>(int&nbsp;index)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Ten largest  31 bit primes: (2^31 - k), k index of POW_2_TO_31_OFFSETS</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>static&nbsp;long</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../ch/javasoft/math/Prime.html#getPrime32(int)">getPrime32</A></B>(int&nbsp;index)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Ten largest  32 bit primes: (2^32 - k), k index of POW_2_TO_32_OFFSETS</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>static&nbsp;long</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../ch/javasoft/math/Prime.html#getPrime63(int)">getPrime63</A></B>(int&nbsp;index)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Ten largest 63 bit primes: (2^63 - k), k index of POW_2_TO_63_OFFSETS</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>static&nbsp;int</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../ch/javasoft/math/Prime.html#getPrimeBelow(int)">getPrimeBelow</A></B>(int&nbsp;n)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Returns the largest prime below n.</TD>
</TR>
</TABLE>
&nbsp;<A NAME="methods_inherited_from_class_java.lang.Object"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#EEEEFF" CLASS="TableSubHeadingColor">
<TH ALIGN="left"><B>Methods inherited from class java.lang.<A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Object.html" title="class or interface in java.lang">Object</A></B></TH>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD><CODE><A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Object.html#clone()" title="class or interface in java.lang">clone</A>, <A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Object.html#equals(java.lang.Object)" title="class or interface in java.lang">equals</A>, <A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Object.html#finalize()" title="class or interface in java.lang">finalize</A>, <A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Object.html#getClass()" title="class or interface in java.lang">getClass</A>, <A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Object.html#hashCode()" title="class or interface in java.lang">hashCode</A>, <A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Object.html#notify()" title="class or interface in java.lang">notify</A>, <A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Object.html#notifyAll()" title="class or interface in java.lang">notifyAll</A>, <A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Object.html#toString()" title="class or interface in java.lang">toString</A>, <A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Object.html#wait()" title="class or interface in java.lang">wait</A>, <A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Object.html#wait(long)" title="class or interface in java.lang">wait</A>, <A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Object.html#wait(long, int)" title="class or interface in java.lang">wait</A></CODE></TD>
</TR>
</TABLE>
&nbsp;
<P>

<!-- ========= CONSTRUCTOR DETAIL ======== -->

<A NAME="constructor_detail"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="1"><FONT SIZE="+2">
<B>Constructor Detail</B></FONT></TH>
</TR>
</TABLE>

<A NAME="Prime()"><!-- --></A><H3>
Prime</H3>
<PRE>
public <A HREF="../../../src-html/ch/javasoft/math/Prime.html#line.46"><B>Prime</B></A>()</PRE>
<DL>
</DL>

<!-- ============ METHOD DETAIL ========== -->

<A NAME="method_detail"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="1"><FONT SIZE="+2">
<B>Method Detail</B></FONT></TH>
</TR>
</TABLE>

<A NAME="getPrime63(int)"><!-- --></A><H3>
getPrime63</H3>
<PRE>
public static long <A HREF="../../../src-html/ch/javasoft/math/Prime.html#line.74"><B>getPrime63</B></A>(int&nbsp;index)</PRE>
<DL>
<DD>Ten largest 63 bit primes: (2^63 - k), k index of POW_2_TO_63_OFFSETS
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>index</CODE> - use 0..length(POW_2_TO_63_OFFSETS)
<DT><B>Returns:</B><DD>63 bit prime 2^63 - POW_2_TO_63_OFFSETS[index]</DL>
</DD>
</DL>
<HR>

<A NAME="getPrime32(int)"><!-- --></A><H3>
getPrime32</H3>
<PRE>
public static long <A HREF="../../../src-html/ch/javasoft/math/Prime.html#line.83"><B>getPrime32</B></A>(int&nbsp;index)</PRE>
<DL>
<DD>Ten largest  32 bit primes: (2^32 - k), k index of POW_2_TO_32_OFFSETS
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>index</CODE> - use 0..length(POW_2_TO_32_OFFSETS)
<DT><B>Returns:</B><DD>32 bit prime 2^32 - POW_2_TO_32_OFFSETS[index]</DL>
</DD>
</DL>
<HR>

<A NAME="getPrime31(int)"><!-- --></A><H3>
getPrime31</H3>
<PRE>
public static int <A HREF="../../../src-html/ch/javasoft/math/Prime.html#line.92"><B>getPrime31</B></A>(int&nbsp;index)</PRE>
<DL>
<DD>Ten largest  31 bit primes: (2^31 - k), k index of POW_2_TO_31_OFFSETS
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>index</CODE> - use 0..length(POW_2_TO_31_OFFSETS)
<DT><B>Returns:</B><DD>31 bit prime 2^31 - POW_2_TO_31_OFFSETS[index]</DL>
</DD>
</DL>
<HR>

<A NAME="getPrime30(int)"><!-- --></A><H3>
getPrime30</H3>
<PRE>
public static int <A HREF="../../../src-html/ch/javasoft/math/Prime.html#line.101"><B>getPrime30</B></A>(int&nbsp;index)</PRE>
<DL>
<DD>Ten largest  30 bit primes: (2^30 - k), k index of POW_2_TO_30_OFFSETS
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>index</CODE> - use 0..length(POW_2_TO_30_OFFSETS)
<DT><B>Returns:</B><DD>30 bit prime 2^30 - POW_2_TO_30_OFFSETS[index]</DL>
</DD>
</DL>
<HR>

<A NAME="getPrime16(int)"><!-- --></A><H3>
getPrime16</H3>
<PRE>
public static int <A HREF="../../../src-html/ch/javasoft/math/Prime.html#line.110"><B>getPrime16</B></A>(int&nbsp;index)</PRE>
<DL>
<DD>Ten largest  16 bit primes: (2^16 - k), k index of POW_2_TO_16_OFFSETS
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>index</CODE> - use 0..length(POW_2_TO_16_OFFSETS)
<DT><B>Returns:</B><DD>16 bit prime 2^16 - POW_2_TO_16_OFFSETS[index]</DL>
</DD>
</DL>
<HR>

<A NAME="getPrime15(int)"><!-- --></A><H3>
getPrime15</H3>
<PRE>
public static int <A HREF="../../../src-html/ch/javasoft/math/Prime.html#line.119"><B>getPrime15</B></A>(int&nbsp;index)</PRE>
<DL>
<DD>Ten largest  15 bit primes: (2^15 - k), k index of POW_2_TO_15_OFFSETS
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>index</CODE> - use 0..length(POW_2_TO_15_OFFSETS)
<DT><B>Returns:</B><DD>32 bit prime 2^15 - POW_2_TO_15_OFFSETS[index]</DL>
</DD>
</DL>
<HR>

<A NAME="getPrime08(int)"><!-- --></A><H3>
getPrime08</H3>
<PRE>
public static int <A HREF="../../../src-html/ch/javasoft/math/Prime.html#line.128"><B>getPrime08</B></A>(int&nbsp;index)</PRE>
<DL>
<DD>Ten largest  8 bit primes: (2^8 - k), k index of POW_2_TO_08_OFFSETS
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>index</CODE> - use 0..length(POW_2_TO_08_OFFSETS)
<DT><B>Returns:</B><DD>8 bit prime 2^8 - POW_2_TO_08_OFFSETS[index]</DL>
</DD>
</DL>
<HR>

<A NAME="getPrime07(int)"><!-- --></A><H3>
getPrime07</H3>
<PRE>
public static int <A HREF="../../../src-html/ch/javasoft/math/Prime.html#line.137"><B>getPrime07</B></A>(int&nbsp;index)</PRE>
<DL>
<DD>Ten largest  7 bit primes: (2^7 - k), k index of POW_2_TO_07_OFFSETS
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>index</CODE> - use 0..length(POW_2_TO_07_OFFSETS)
<DT><B>Returns:</B><DD>7 bit prime 2^7 - POW_2_TO_07_OFFSETS[index]</DL>
</DD>
</DL>
<HR>

<A NAME="getPrime(int)"><!-- --></A><H3>
getPrime</H3>
<PRE>
public static int <A HREF="../../../src-html/ch/javasoft/math/Prime.html#line.150"><B>getPrime</B></A>(int&nbsp;index)</PRE>
<DL>
<DD>Returns the <tt>index</tt><sup>th</sup> prime, for instance, 2 if index 
 is 0, 3 if index=1 and so on. The underlying algorithm is approximately
 linear in index.
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>index</CODE> - the index of the desired prime, 0 for prime 2, 1 for prime 3
                                and so on
<DT><B>Returns:</B><DD>the <tt>index</tt><sup>th</sup> prime</DL>
</DD>
</DL>
<HR>

<A NAME="getPrimeBelow(int)"><!-- --></A><H3>
getPrimeBelow</H3>
<PRE>
public static int <A HREF="../../../src-html/ch/javasoft/math/Prime.html#line.181"><B>getPrimeBelow</B></A>(int&nbsp;n)</PRE>
<DL>
<DD>Returns the largest prime below n. The underlying algorithm is 
 approximately linear in n.
<P>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="countPrimes(int, boolean, boolean)"><!-- --></A><H3>
countPrimes</H3>
<PRE>
public static int <A HREF="../../../src-html/ch/javasoft/math/Prime.html#line.295"><B>countPrimes</B></A>(int&nbsp;till,
                              boolean&nbsp;trace,
                              boolean&nbsp;traceAllPrimes)</PRE>
<DL>
<DD>Counts the primes until (inclusive) till, using default cache size,
 tracing intermediary counts if trace is true, and printing all primes
 if traceAllPrimes is true. Returns the number of primes found.
<P>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="countPrimes(int, int, boolean, boolean)"><!-- --></A><H3>
countPrimes</H3>
<PRE>
public static int <A HREF="../../../src-html/ch/javasoft/math/Prime.html#line.305"><B>countPrimes</B></A>(int&nbsp;till,
                              int&nbsp;cacheSize,
                              boolean&nbsp;trace,
                              boolean&nbsp;traceAllPrimes)</PRE>
<DL>
<DD>Counts the primes until (inclusive) till, using a cache of size cacheSize,
 tracing intermediary counts if trace is true, and printing all primes
 if traceAllPrimes is true. Returns the number of primes found.
<P>
<DD><DL>
</DL>
</DD>
</DL>
<!-- ========= END OF CLASS DATA ========= -->
<HR>


<!-- ======= START OF BOTTOM NAVBAR ====== -->
<A NAME="navbar_bottom"><!-- --></A>
<A HREF="#skip-navbar_bottom" title="Skip navigation links"></A>
<TABLE BORDER="0" WIDTH="100%" CELLPADDING="1" CELLSPACING="0" SUMMARY="">
<TR>
<TD COLSPAN=2 BGCOLOR="#EEEEFF" CLASS="NavBarCell1">
<A NAME="navbar_bottom_firstrow"><!-- --></A>
<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="3" SUMMARY="">
  <TR ALIGN="center" VALIGN="top">
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../overview-summary.html"><FONT CLASS="NavBarFont1"><B>Overview</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="package-summary.html"><FONT CLASS="NavBarFont1"><B>Package</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#FFFFFF" CLASS="NavBarCell1Rev"> &nbsp;<FONT CLASS="NavBarFont1Rev"><B>Class</B></FONT>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="class-use/Prime.html"><FONT CLASS="NavBarFont1"><B>Use</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="package-tree.html"><FONT CLASS="NavBarFont1"><B>Tree</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../deprecated-list.html"><FONT CLASS="NavBarFont1"><B>Deprecated</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../index-files/index-1.html"><FONT CLASS="NavBarFont1"><B>Index</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../help-doc.html"><FONT CLASS="NavBarFont1"><B>Help</B></FONT></A>&nbsp;</TD>
  </TR>
</TABLE>
</TD>
<TD ALIGN="right" VALIGN="top" ROWSPAN=3><EM>
</EM>
</TD>
</TR>

<TR>
<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
&nbsp;<A HREF="../../../ch/javasoft/math/NumberOperations.html" title="interface in ch.javasoft.math"><B>PREV CLASS</B></A>&nbsp;
&nbsp;NEXT CLASS</FONT></TD>
<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
  <A HREF="../../../index.html?ch/javasoft/math/Prime.html" target="_top"><B>FRAMES</B></A>  &nbsp;
&nbsp;<A HREF="Prime.html" target="_top"><B>NO FRAMES</B></A>  &nbsp;
&nbsp;<SCRIPT type="text/javascript">
  <!--
  if(window==top) {
    document.writeln('<A HREF="../../../allclasses-noframe.html"><B>All Classes</B></A>');
  }
  //-->
</SCRIPT>
<NOSCRIPT>
  <A HREF="../../../allclasses-noframe.html"><B>All Classes</B></A>
</NOSCRIPT>


</FONT></TD>
</TR>
<TR>
<TD VALIGN="top" CLASS="NavBarCell3"><FONT SIZE="-2">
  SUMMARY:&nbsp;NESTED&nbsp;|&nbsp;FIELD&nbsp;|&nbsp;<A HREF="#constructor_summary">CONSTR</A>&nbsp;|&nbsp;<A HREF="#method_summary">METHOD</A></FONT></TD>
<TD VALIGN="top" CLASS="NavBarCell3"><FONT SIZE="-2">
DETAIL:&nbsp;FIELD&nbsp;|&nbsp;<A HREF="#constructor_detail">CONSTR</A>&nbsp;|&nbsp;<A HREF="#method_detail">METHOD</A></FONT></TD>
</TR>
</TABLE>
<A NAME="skip-navbar_bottom"></A>
<!-- ======== END OF BOTTOM NAVBAR ======= -->

<HR>

</BODY>
</HTML>
